#include<bits/stdc++.h>
using namespace std;
ifstream fi("matran.inp");
ofstream fo("matran.out");
int m,n;
int m1,n1,a[10000][10000];
int tg(int x, int y)
{
    int s=0;
    //fo<<m1<<n1<<endl;
    for(int k=x;k<x+m1;k++)
    {
        for(int g=y;g<y+n1;g++)
        {
            s=s+a[k][g];
          //  fo<<a[i][j]<<' ';
        }
    }
   // fo<<endl;
    return s;
}
int max(int d)
{
    int r=a[d][0];
    for(int i=1;i<n;i++)
    {
        if(a[d][i]>r)
        {
            r=a[d][i];
        }
    }
    return r;
}
int main()
{
    fi>>m>>n;
    for(int i=0;i<m;i++)
    {
        for(int j=0;j<n;j++)
        {
            fi>>a[i][j];
        }
    }
    int mx=0;
    int dau,cuoi;
    int km,kn;
    for(m1=1;m1<=m;m1++)
    {
    	for(n1=1;n1<=n;n1++)
    	{
    		for(int i=0;i<m-m1+1;i++)
    		{
        		for(int j=0;j<n-n1+1;j++)
        		{
            		if(tg(i,j)>mx)
            		{
                		mx=tg(i,j);
                		dau=i;
                		cuoi=j;
						km=m1;
                		kn=n1;
            		}
        		}
    		}
    	}
    }
    for(int i=dau;i<dau+km;i++)
    {
        for(int j=cuoi;j<cuoi+kn;j++)
        {
            fo<<setw(4)<<a[i][j];
        }
        fo<<endl;
    }
    for(int i=0;i<m;i++)
    {
        fo<<max(i)<<endl;
    }
}
